import numpy as np
import matplotlib.pyplot as plt
import scipy.io as scio

ff, dcpda, dcpdb = np.loadtxt('DcpdIOP.txt', unpack=1)

p1 = 13.7e3
p2 = 17.8e3
uncompOmc = 1/(1+1j*ff/p1)/(1+1j*ff/p2)
aa = scio.loadmat('analog_65k_AAAI_filter_response_T1500165.mat')
tf_aa = np.squeeze(aa['aamodel'][0][0][0])
f_aa = np.squeeze(aa['aamodel'][0][0][1])
tf_aa_re = np.interp(ff, f_aa, np.real(tf_aa))
tf_aa_im = np.interp(ff, f_aa, np.imag(tf_aa))
tf_aa = tf_aa_re + 1j*tf_aa_im
'''
_, dcpdalp = sig.freqs(*sig.butter(3, 2*np.pi*10e3, analog=True), worN=2*np.pi*ff)

wnot = 2*np.pi*65536
Qnot = 0.15
depth = 1/300
_, Hnot = sig.freqs([1, depth*wnot/Qnot, wnot**2],
        [1, wnot/Qnot, wnot**2], worN=2*np.pi*ff)
'''

totlp = uncompOmc*tf_aa

plt.figure(figsize=(8, 6))
plt.loglog(ff, dcpda, c=(0.7, 0, 0), alpha=0.8, label='DCPD A')
plt.loglog(ff, 0.091*np.abs(uncompOmc), c=(0, 0, 0.7), alpha=0.8,
        label='Preamp only')
plt.loglog(ff, 0.091*np.abs(uncompOmc*tf_aa), c=(0, 0.5, 0), alpha=0.8,
        label='Preamp and AA')
plt.xlim(100, 29000)
plt.ylim(3e-3, 3)
plt.legend(fancybox=True, loc=3)
plt.xlabel('Frequency [Hz]')
plt.ylabel(r'ASD (ct/Hz$^{1/2}$)')
plt.title('Uncompensated electronics poles in the OMC chain')
plt.tight_layout()
plt.savefig('DcpdIOP.pdf')
